<template>
    <div class="outStore">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">出仓管理</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getOutStoreList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="carcassCode" label="胴体编码" width="180"></el-table-column>
                    <el-table-column prop="deliveryTime" label="出库时间" width="180"></el-table-column>
                    <el-table-column prop="flowTo" label="去向">
                        <template v-slot="scope">
                            <div
                                v-for="item in $store.state['outStoreDirection']"
                                :key="item.value"
                            >
                                <span v-if="item.value == scope.row['flowTo']">{{ item.label }}</span>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column prop="deliveryWeight" label="出库重量" width="180"></el-table-column>
                    <el-table-column prop="operator" label="操作人员"></el-table-column>
                    <el-table-column prop="slaughterBatch" label="屠宰批次"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addOutStore" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="胴体编码">
                            <el-input v-model="formData.carcassCode"></el-input>
                        </el-form-item>

                        <el-form-item label="出库时间">
                            <el-date-picker
                                v-model="formData.deliveryTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="去向">
                            <el-radio-group v-model="formData.flowTo">
                                <el-radio
                                    v-for="item in $store.state['outStoreDirection']"
                                    :key="item.value"
                                    :label="item.value"
                                >{{ item.label }}</el-radio>
                            </el-radio-group>
                        </el-form-item>

                        <el-form-item label="出库重量">
                            <el-input v-model="formData.deliveryWeight"></el-input>
                        </el-form-item>

                        <el-form-item label="操作人员">
                            <el-input v-model="formData.operator"></el-input>
                        </el-form-item>

                        <el-form-item label="屠宰批次">
                            <el-input v-model="formData.slaughterBatch"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addOutStore')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqOutStoreList,
    reqAddOutStore,
    reqUpdateOutStore,
    reqDelOutStore
} from "@/api/slaughterManagment.js";

const pageSize = 10;
const rules = {};

export default {
    name: "OutStore",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                carcassCode: "1010",
                deliveryTime: this.$moment().format("YYYY-MM-DD"),
                flowTo: this.$store.state["outStoreDirection"][0].value,
                deliveryWeight: "48",
                operator: "王三喜",
                slaughterBatch: "16546"
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 出仓管理列表
        this.getOutStoreList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddOutStore(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getOutStoreList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateOutStore(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getOutStoreList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 出仓管理列表
        getOutStoreList() {
            reqOutStoreList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false;
        },
        del(row) {
            reqDelOutStore(row.id)
                .then(res => {
                    console.log(res);
                    // 出仓管理列表
                    this.getOutStoreList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 出仓管理列表
            this.getOutStoreList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>